******************************************************************
**								**
**	openwin - window open sub-routine			**
**								**
**	[description]	window  open (mintdisp like)		**
**			text plane 0,1 gp			**
**			call O supervisor mode ɈڍsĂ	**
**			parameter check ͂Ȃ̂Œ	**
**	[call]		_openwin				**
**	[arguments]	long &(window \)			**
**	[return]	none					**
**	[version]	1.00					**
**	[author]	Ö(Tsunami)				**
**								**
******************************************************************


.include	iocscall.mac
.include	window.h

.xdef		_openwin

openwinreg	reg		d0-d7/a0-a5		*  gp register

.offset		0					*  local work `

txline_plane:	ds.w		1			*  text plane no.
txline_xpos:	ds.w		1			*  x position
txline_ypos:	ds.w		1			*  y position
txline_length:	ds.w		1			*  length
txline_style:	ds.w		1			*  line style
txline_struct:

.offset		0

		ds.b		win_struct
		ds.b		txline_struct
ow_worksize:

.offset		-ow_worksize

window_work:	ds.b		win_struct
txline_work:	ds.b		txline_struct

.text

_openwin:	link		a6,#-ow_worksize
		movem.l		openwinreg,-(sp)
		move.w		sr,-(sp)
							*  window \  work  copy
		movea.l		8(a6),a0		*  a0: &(window \)
		lea		window_work(a6),a1
		move.w		#win_struct,d1
		subq.w		#1,d1
@@:		move.b		(a0)+,(a1)+
		dbf		d1,@b
*
		movea.l		#$e00000,a0		*  a0: &(window `JnW
							*        plane 0)
		adda.w		win_x1+window_work(a6),a0
		move.w		win_y1+window_work(a6),d0
		ext.l		d0
		lsl.l		#8,d0
		lsl.l		#3,d0
		adda.l		d0,a0
		pea		(a0)			*  a0 ޔ
*
							*-- buffer ֑ޔE
							*---- ޔO
		movea.l		a0,a2			*  a2: &(window `JnW
		adda.l		#$20000,a2		*        plane 1)
		movea.l		buff_addr+window_work(a6),a1	*  a1: &(ޔ buffer plane 0)
		movea.l		a1,a3			*  a3: &(ޔ buffer plane 1)
		move.w		win_xsize+window_work(a6),d0	*  d0: winx_size
		ext.l		d0
		move.l		d0,d1
		lsl.l		#4,d1
		move.w		win_ysize+window_work(a6),d2
		subq.w		#1,d2
		moveq.l		#0,d3
@@:		add.l		d1,d3
		dbf		d2,@b
		adda.l		d3,a3
		move.w		#$80,d3			*  d3: text-vram y 
		sub.w		d0,d3
		move.w		win_ysize+window_work(a6),d2	*  d2: y counter (decrement)
		lsl.w		#4,d2
		subq.w		#1,d2
		lea		openwin1_1_1(pc),a4	*  a4: ]p jump address
		move.w		d0,d1
		subi.w		#128,d1
		neg.w		d1
		add.w		d1,d1
		add.w		d1,d1
		adda.w		d1,a4
							*---- ޔ
openwin1_1:	jmp		(a4)
openwin1_1_1:	move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		move.b		(a0)+,(a1)+
		move.b		(a2)+,(a3)+
		adda.w		d3,a0			*  next line
		adda.w		d3,a2
		dbf		d2,openwin1_1
							*---- O
		move.w		win_xsize+window_work(a6),d0	*  d0: winx_size
		move.w		#$80,d3			*  d3: text-vram y 
		sub.w		d0,d3
		movea.l		(sp),a0			*  a0: Jn text-vram address
		move.l		a0,d5			*  d5: Jn address p
		andi.b		#%0000_0001,d5
		tst.b		d5			*   address Ŏn ?
		beq		@f			*  yes
		subq.w		#1,d0			*  ŏ 1byte ]邽
							*  ̕Ă
@@:		lea		openwin1_2_1(pc),a2	*  a2: longword Pʓ]p
		move.w		d0,d1			*      jump address
		lsr.w		#2,d1			*    1 line  1 longword 
		subi.w		#32,d1			*    longword ]Ȃ
		neg.w		d1
		add.w		d1,d1
		adda.w		d1,a2
		lea		ow1_jmptbl(pc),a3	*  a3: byte Pʓ]p
		move.w		d0,d1			*      jump address
		andi.w		#$3,d1
		add.w		d1,d1
		adda.w		(a3,d1.w),a3
		moveq.l		#0,d0			*  d0: p
		move.w		win_ysize+window_work(a6),d2	*  d2: y counter (decrement)
		lsl.w		#4,d2
		subq.w		#1,d2
@@:		btst.b		#4,$e88001		*  plane 0,1 ANZXݒ
		beq		@b
@@:		btst.b		#4,$e88001
		bne		@b
		move.w		$e8002a,d1		*  d1: $e8002a ޔ
		move.w		#%01_0011_0000,$e8002a
							*---- 
openwin1_2:	tst.b		d5			*   address Ŏn ?
		beq		openwin1_2_0		*  yes
		move.b		d0,(a0)+		*  1byte 
openwin1_2_0:	jmp		(a2)
openwin1_2_1:	move.l		d0,(a0)+		*  longword Pʏ
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		move.l		d0,(a0)+
		jmp		(a3)
ow1_jmptbl:	dc.w		openwin1_2_5-ow1_jmptbl	*  byte PʏȂ
		dc.w		openwin1_2_4-ow1_jmptbl	*  1byte 
		dc.w		openwin1_2_3-ow1_jmptbl	*  2byte 
		dc.w		openwin1_2_2-ow1_jmptbl	*  3byte 
openwin1_2_2:	move.b		d0,(a0)+		*  byte Pʏ
openwin1_2_3:	move.b		d0,(a0)+
openwin1_2_4:	move.b		d0,(a0)+
openwin1_2_5:	adda.w		d3,a0			*  next line
		dbf		d2,openwin1_2
@@:		btst.b		#4,$e88001		*  plane 0,1 ANZX~
		beq		@b
@@:		btst.b		#4,$e88001
		bne		@b
		move.w		d1,$e8002a
*
							*-- header \
							*---- \
		moveq.l		#0,d2			*  d2: ėp counter
							*     word clear
		movea.l		(sp)+,a0		*  a0 A
		movea.l		a0,a2			*  a2: &(header  text-vram)
		movea.l		a0,a3			*  a3: &(a2 Ƒ΂ plane 0 or 1)
		adda.l		#$20000,a3		*  a2  plane 0Ca3  plane 1
		cmpi.w		#2,win_color+window_work(a6)	*  win_color = 2 ?
		bne		@f			*  no
		adda.l		#$20000,a2		*  a2  plane 1Ca3  plane 0
		movea.l		a0,a3
@@:		move.w		header_x1+window_work(a6),d2	*  d2: x counter (decrement)
		beq		openwin2_2		*  Ȃ header 
							*    header 񕔕\
		lea		header_echr1(pc),a5
		subq.w		#1,d2
		bne		openwin2_1_1		*  header 񕔎OłȂ
		lea		header_chr1(pc),a4	*  [Cheader 񕔎O
		bsr		putheadchr
		bra		openwin2_2		*  quit: header 񕔕\
openwin2_1_1:	lea		header_chr2(pc),a4	*  [Cheader 񕔎OłȂ
		bsr		putheadchr
		lea		header_chr3(pc),a4
		lea		header_echr3(pc),a5
		subq.w		#1,d2
		beq		openwin2_1_2		*  header 񕔎O
		subq.w		#1,d2
@@:		bsr		putheadchr		*  rCheader 񕔎OłȂ
		dbf		d2,@b			*  next
openwin2_1_2:	lea		header_chr4(pc),a4	*  rCheader 񕔎O
		bsr		putheadchr
							*---- header 񕔕\
							*------ \
openwin2_2:	tst.w		header_size+window_work(a6)		*  header_size = 0 ?
		beq		openwin2_3		*  yes: E\
		tst.l		header_addr+window_work(a6)		*  &(header) = 0 ?
		beq		openwin2_3		*  yes: E\
		moveq.l		#-1,d1
		IOCS		_B_LOCATE
		move.l		d0,d5			*  d5:  cursor position
		moveq.l		#-1,d1
		IOCS		_B_COLOR
		move.w		d0,d6			*  d6: ̕ color 
		move.w		win_color+window_work(a6),d1	*  win_color 𔽓]
		addq.w		#8,d1
		move.w		win_x1+window_work(a6),d2
		add.w		header_x1+window_work(a6),d2
		move.w		win_y1+window_work(a6),d3
		move.w		header_size+window_work(a6),d4
		subq.w		#1,d4
		movea.l		header_addr+window_work(a6),a1
		IOCS		_B_PUTMES
		move.w		d6,d1
		IOCS		_B_COLOR		*  color 
		move.l		d5,d1			*  cursor position 
		move.w		d1,d2
		swap		d1
		IOCS		_B_LOCATE
							*------ 񕔏㉺[
		moveq.l		#-1,d0
		sf		d1
		move.w		header_size+window_work(a6),d2 	*  d2: x counter (decrement)
		subq.w		#1,d2
@@:		move.b		d0,(a3)+
		move.b		d1,$80(a2)
		move.b		d0,$77f(a3)		*  Fς
		addq.l		#1,a2			*  1 character x 
		dbf		d2,@b
							*---- E\
openwin2_3:	move.w		win_xsize+window_work(a6),d2	*  d2: x counter (decrement)
		sub.w		header_x1+window_work(a6),d2
		sub.w		header_size+window_work(a6),d2
		beq		openwin3		*  Ȃ window E[
							*    header  quit
		lea		header_chr5(pc),a4	*  [Cwindow E[O
		lea		header_echr2(pc),a5	*   [Cwindow E[OłȂ
		bsr		putheadchr		*    pattern
		subq.w		#1,d2
		beq		openwin3		*  [Cwindow E[O
		subq.w		#1,d2
		lea		header_chr3(pc),a4	*  rCwindow E[OłȂ
		lea		header_echr3(pc),a5	*   rCwindow E[O
@@:		bsr		putheadchr		*    pattern
		dbf		d2,@b			*  next
*
							*-- window `
openwin3:	lea		txline_work(a6),a1
		move.w		win_color+window_work(a6),txline_plane+txline_work(a6)
		subi.w		#1,txline_plane+txline_work(a6)
		move.w		#$ffff,txline_style+txline_work(a6)
		move.w		win_x1+window_work(a6),d0
		lsl.w		#3,d0
		move.w		d0,txline_xpos+txline_work(a6)
		move.w		win_y1+window_work(a6),d0
		addq.w		#1,d0
		lsl.w		#4,d0
		move.w		d0,txline_ypos+txline_work(a6)
		move.w		win_ysize+window_work(a6),d2
		subq.w		#2,d2
		lsl.w		#4,d2
		addi.w		#15,d2
		move.w		d2,txline_length+txline_work(a6)
		IOCS		_TXYLINE
		move.w		win_xsize+window_work(a6),d1
		subq.w		#1,d1
		lsl.w		#3,d1
		addq.w		#7,d1
		add.w		d1,txline_xpos+txline_work(a6)
		IOCS		_TXYLINE
		sub.w		d1,txline_xpos+txline_work(a6)
		add.w		d2,txline_ypos+txline_work(a6)
		move.w		d1,txline_length+txline_work(a6)
		IOCS		_TXXLINE
*
							*-- Quit
		move.w		(sp)+,sr
		movem.l		(sp)+,openwinreg
		unlk		a6
		rts
*
							* Put header character ---------
							*  [arg]  a2: &(ʏpat.ʒu)
							*	  a3: &(pat.ʒu)
							*	  a4: &(ʏ pattern)
							*	  a5: &( pattern)
							*  [rtn]  a2: +1
							*	  a3: +1
putheadchr:	move.b		(a4)+,(a2)+
		move.b		(a4)+,$7f(a2)
		move.b		(a4)+,$ff(a2)
		move.b		(a4)+,$17f(a2)
		move.b		(a4)+,$1ff(a2)
		move.b		(a4)+,$27f(a2)
		move.b		(a4)+,$2ff(a2)
		move.b		(a4)+,$37f(a2)
		move.b		(a4)+,$3ff(a2)
		move.b		(a4)+,$47f(a2)
		move.b		(a4)+,$4ff(a2)
		move.b		(a4)+,$57f(a2)
		move.b		(a4)+,$5ff(a2)
		move.b		(a4)+,$67f(a2)
		move.b		(a4)+,$6ff(a2)
		move.b		(a4)+,$77f(a2)
		move.b		(a5)+,(a3)+
		move.b		(a5)+,$7f(a3)
		move.b		(a5)+,$ff(a3)
		move.b		(a5)+,$17f(a3)
		move.b		(a5)+,$1ff(a3)
		move.b		(a5)+,$27f(a3)
		move.b		(a5)+,$2ff(a3)
		move.b		(a5)+,$37f(a3)
		move.b		(a5)+,$3ff(a3)
		move.b		(a5)+,$47f(a3)
		move.b		(a5)+,$4ff(a3)
		move.b		(a5)+,$57f(a3)
		move.b		(a5)+,$5ff(a3)
		move.b		(a5)+,$67f(a3)
		move.b		(a5)+,$6ff(a3)
		move.b		(a5)+,$77f(a3)
		lea		-16(a4),a4
		lea		-16(a5),a5
		rts
*
							*-- header character pattern
header_chr1:	dc.b		%1111_1111		*  [獶I[p
		dc.b		%1100_0000
		dc.b		%1111_1110
		dc.b		%1100_0000
		dc.b		%1111_1110
		dc.b		%1100_0000
		dc.b		%1111_1110
		dc.b		%1100_0000
		dc.b		%1111_1110
		dc.b		%1100_0000
		dc.b		%1111_1110
		dc.b		%1100_0000
		dc.b		%1111_1110
		dc.b		%1100_0000
		dc.b		%1111_1110
		dc.b		%1100_0000
header_chr2:	dc.b		%1111_1111		*  [rp
		dc.b		%1100_0000
		dc.b		%1111_1111
		dc.b		%1100_0000
		dc.b		%1111_1111
		dc.b		%1100_0000
		dc.b		%1111_1111
		dc.b		%1100_0000
		dc.b		%1111_1111
		dc.b		%1100_0000
		dc.b		%1111_1111
		dc.b		%1100_0000
		dc.b		%1111_1111
		dc.b		%1100_0000
		dc.b		%1111_1111
		dc.b		%1100_0000
header_chr3:	dc.b		%1111_1111		*  rp
		dc.b		%0000_0000		*  ErEI[p
		dc.b		%1111_1111
		dc.b		%0000_0000
		dc.b		%1111_1111
		dc.b		%0000_0000
		dc.b		%1111_1111
		dc.b		%0000_0000
		dc.b		%1111_1111
		dc.b		%0000_0000
		dc.b		%1111_1111
		dc.b		%0000_0000
		dc.b		%1111_1111
		dc.b		%0000_0000
		dc.b		%1111_1111
		dc.b		%0000_0000
header_chr4:	dc.b		%1111_1111		*  r獶I[p
		dc.b		%0000_0000
		dc.b		%1111_1110
		dc.b		%0000_0000
		dc.b		%1111_1110
		dc.b		%0000_0000
		dc.b		%1111_1110
		dc.b		%0000_0000
		dc.b		%1111_1110
		dc.b		%0000_0000
		dc.b		%1111_1110
		dc.b		%0000_0000
		dc.b		%1111_1110
		dc.b		%0000_0000
		dc.b		%1111_1110
		dc.b		%0000_0000
header_chr5:	dc.b		%1111_1111		*  E[EI[p
		dc.b		%1000_0000		*  E[Erp
		dc.b		%1111_1111
		dc.b		%1000_0000
		dc.b		%1111_1111
		dc.b		%1000_0000
		dc.b		%1111_1111
		dc.b		%1000_0000
		dc.b		%1111_1111
		dc.b		%1000_0000
		dc.b		%1111_1111
		dc.b		%1000_0000
		dc.b		%1111_1111
		dc.b		%1000_0000
		dc.b		%1111_1111
		dc.b		%1000_0000
*
							*-- header character pattern
							*  (pdˍ pattern)
header_echr1:	dc.b		%1111_1111
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
		dc.b		%1100_0000
header_echr2:	dc.b		%1111_1111
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
		dc.b		%1000_0000
header_echr3:	dc.b		%1111_1111
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000
		dc.b		%0000_0000

.even
.end
